 /**
 * <p>Qualitaets- und UnterstuetzungsAgentur - Landesinstitut fuer Schule, Materialien zum schulinternen Lehrplan Informatik SII</p>
 * *
 * @version 2014-03-13
 */
import java.awt.event.*;
import java.io.*;
class HauptKlickEmpfaenger implements ActionListener{
  Hauptansicht haupt;
  List<Karte> lis;

  HauptKlickEmpfaenger(Hauptansicht eingabe, List<Karte> l){
   haupt=eingabe;
   lis=l;
  }
  
  public void actionPerformed(ActionEvent e) {
   if (e.getActionCommand()=="neue Karte"){
     haupt.zeigeNeuFenster();
   }
   else if (e.getActionCommand()=="Karte ändern"){
     haupt.zeigeAenderFenster();
   }
   else if (e.getActionCommand()=="Karte suchen"){
     haupt.zeigeSuchFenster();
   }
   else if (e.getActionCommand()=="Karte löschen"){
     haupt.zeigeWirklichLoeschFenster();
   }
   else if (e.getActionCommand()=="weiter blättern"){
     lis.next();
     haupt.setKarte();
   }
   else if (e.getActionCommand()=="Zur ersten Karte"){
     lis.toFirst();
     haupt.setKarte();
   }
    else if(e.getActionCommand()=="Liste speichern"){
       this.listeSpeichern();
    }
    else if(e.getActionCommand()=="Liste ausgeben"){
       this.listeAusgeben();
       haupt.setKarte();
    }
    else if(e.getActionCommand()=="Liste sortieren (1)"){
       this.sortiere1();
       this.listeAusgeben();
       haupt.nimmListe(lis);
       haupt.setKarte();
    }
     else if(e.getActionCommand()=="Liste sortieren (2)"){
       this.sortiere2();
       this.listeAusgeben();
       haupt.nimmListe(lis);
       haupt.setKarte();
     }
  }
   public void listeAusgeben(){
     lis.toFirst();
     while(lis.hasAccess()){
       System.out.println((lis.getContent()).getName());
       lis.next();
      }
     lis.toFirst();
   }
   public void sortiere1(){
      List<Karte> hilfsliste = new List<Karte>();
      while (!lis.isEmpty()){
        lis.toFirst();
        Karte lKarte = lis.getContent();

            hilfsliste.toFirst();
            while (hilfsliste.hasAccess() && (lKarte.getName().compareTo( (hilfsliste.getContent()).getName())>0)){
                hilfsliste.next();
            }
            if (hilfsliste.hasAccess()){
                hilfsliste.insert(lKarte);
            }
            else{
                hilfsliste.append(lKarte);
            }
            lis.remove();
        }
        hilfsliste.toFirst();
        while (!hilfsliste.isEmpty()) {
           lis.append(hilfsliste.getContent()); 
           hilfsliste.remove();
         }
   }
   
   public void sortiere2(){
        lis.toFirst();
        lis=this.sortiereRekursiv(lis);
   }
   
   private List<Karte> sortiereRekursiv(List<Karte> pListe){
      List<Karte> lGroessere = new List<Karte>();
      List<Karte> lKleinere = new List<Karte>();
      if (!pListe.isEmpty()){
        pListe.toFirst();
        Karte lTrennelement = pListe.getContent();
        pListe.remove();
        if(!pListe.isEmpty()){
          pListe.toFirst();
          while ((!pListe.isEmpty())&&pListe.hasAccess()){
            if ((pListe.getContent()).getName().compareTo(lTrennelement.getName())<0){
                lKleinere.append(pListe.getContent());
            }
            else{
              lGroessere.append(pListe.getContent());
            }
            pListe.remove();
            pListe.toFirst();
          }

        }
          lGroessere=this.sortiereRekursiv(lGroessere);
          lKleinere=this.sortiereRekursiv(lKleinere);
          lKleinere.append(lTrennelement);
          lKleinere.concat(lGroessere);
      }
     return lKleinere;
   }

   public Karte binaereSuche(Karte[] k, String pName){
     System.out.println(k.length);
     return binaereSuche(k,pName,0,k.length-1);
   }
   public Karte binaereSuche(Karte[] k, String pName, int i, int j){
     Karte hilf1=null;
     Karte hilf2=null;
     if((i==j)&&k[j].getName().equals(pName))
       return k[j];
     if(i<j){
        hilf1=binaereSuche(k,pName,i,(i+j)/2); if(hilf1!=null) return hilf1;
        hilf2=binaereSuche(k,pName,(i+j)/2+1,j); if (hilf2!=null) return hilf2;
     }
     return null;
   }
   
   public void listeSpeichern(){
    FileOutputStream fs;
    ObjectOutputStream os;
      try {
        fs = new FileOutputStream("Kartei.dat");
        os = new ObjectOutputStream(fs);
        lis.toFirst();
        int anzahl=0;
        while (lis.hasAccess()){
            anzahl++; 
            lis.next();
        }
        os.writeInt(anzahl);
        lis.toFirst();
        while (lis.hasAccess()){
           os.writeObject(lis.getContent());
           lis.next();
        } 
        os.close();
        }
        catch (IOException e) {
        System.err.println(e.toString());
      }
   }

}
