 /**
 * <p>Qualitaets- und UnterstuetzungsAgentur - Landesinstitut fuer Schule, Materialien zum schulinternen Lehrplan Informatik SII</p>
 * *
 * @version 2014-03-13
 */
import javax.swing.*;
import java.awt.event.*;
import java.awt.*;

class Hauptansicht {
  NeuFenster e;
  AenderFenster a;
  SuchFenster s;
  StartFenster start;
  WirklichLoeschFenster l;
  JFrame menue;
  JLabel name, strasse,plz, wohnort, leer;
  JLabel anzeigeName, anzeigeStrasse,anzeigePLZ, anzeigeWohnort, ueberschrift;
  JButton neu,suchen,aendern,loeschen, weiter, anAnfang, speichern, ausgeben;
  JButton sortieren1,sortieren2;
  JPanel contentPane;
  HauptKlickEmpfaenger klemp;
  FensterSchliesser fs;
  GridLayout grilay;
  List<Karte> lis;
  Karte k;

  Hauptansicht(List<Karte> listeVonStart){
    lis=listeVonStart;
    lis.toFirst();
    menue=new JFrame("Hauptmenü");
    contentPane=new JPanel();
    grilay=new GridLayout(0,2);
    contentPane.setLayout(grilay);
    klemp=new HauptKlickEmpfaenger(this, lis);
    ueberschrift=new JLabel("Aktuelle Karte:");
    leer=new JLabel();

    anzeigeName=new JLabel("Name: ");
    anzeigeStrasse=new JLabel("Strasse: ");
    anzeigePLZ=new JLabel("PLZ: ");
    anzeigeWohnort=new JLabel("Wohnort: ");
    
    name=new JLabel("name1");
    strasse=new JLabel("strasse1");
    plz=new JLabel("plz1");
    wohnort=new JLabel("wohnort1");
    
    neu=new JButton("neue Karte");
    neu.addActionListener(klemp);
    suchen=new JButton("Karte suchen");
    suchen.addActionListener(klemp);
    aendern=new JButton("Karte ändern");
    aendern.addActionListener(klemp);
    loeschen=new JButton("Karte löschen");
    loeschen.addActionListener(klemp);
    weiter=new JButton("weiter blättern");
    weiter.addActionListener(klemp);
    anAnfang=new JButton("Zur ersten Karte");
    anAnfang.addActionListener(klemp);
    speichern=new JButton("Liste speichern");
    speichern.addActionListener(klemp);
    ausgeben=new JButton("Liste ausgeben");
    ausgeben.addActionListener(klemp);
    sortieren1=new JButton("Liste sortieren (1)");
    sortieren1.addActionListener(klemp);
    sortieren2=new JButton("Liste sortieren (2)");
    sortieren2.addActionListener(klemp);

    contentPane.add(ueberschrift);
    contentPane.add(leer);
    contentPane.add(anzeigeName);
    contentPane.add(name);
    contentPane.add(anzeigeStrasse);
    contentPane.add(strasse);
    contentPane.add(anzeigePLZ);
    contentPane.add(plz);
    contentPane.add(anzeigeWohnort);
    contentPane.add(wohnort);

    contentPane.add(neu);
    contentPane.add(suchen);
    contentPane.add(aendern);
    contentPane.add(loeschen);
    contentPane.add(weiter);
    contentPane.add(anAnfang);
    contentPane.add(speichern);
    contentPane.add(ausgeben);
    contentPane.add(sortieren1);
    contentPane.add(sortieren2);
    
    fs=new FensterSchliesser();
    menue.addWindowListener(fs);
    menue.setContentPane(contentPane);
    menue.pack();
    menue.setSize(600,300);
    menue.setVisible(true);
    e=new NeuFenster(lis,this);
    e.macheUnsichtbar();
    a=new AenderFenster(lis,this);
    a.macheUnsichtbar();
    s=new SuchFenster(lis,this);
    s.macheUnsichtbar();
    l=new WirklichLoeschFenster(lis,this);
    l.macheUnsichtbar();
  }

  void setKarte(){
   if((!lis.isEmpty())&&(lis.hasAccess())){
    name.setText((lis.getContent()).getName());
    wohnort.setText((lis.getContent()).getWohnort());
    plz.setText((lis.getContent()).getPLZ()+"");
    strasse.setText((lis.getContent()).getStrasse());
   }
   else{
     name.setText("Momentan kein Zugriff auf eine Karte!");
     wohnort.setText("         ");
    plz.setText("          ");
    strasse.setText("         ");
   }
  }
  void zeigeAenderFenster(){
    a.macheSichtbar();
    k=lis.getContent();
    a.setAltenName(k.getName());
    a.setAlteStrasse(k.getStrasse());
    a.setAltePLZ(k.getPLZ());
    a.setAltenWohnort(k.getWohnort());
    a.setKarte();
  }
  void versteckeAenderFenster(){
      a.macheUnsichtbar();
  }
  void zeigeSuchFenster(){
    s.macheSichtbar();
  }
  void versteckeSuchFenster(){
      s.macheUnsichtbar();
  }
  void zeigeNeuFenster(){
    e.macheSichtbar();
  }
  void versteckeNeuFenster(){
      e.macheUnsichtbar();
  }
  void zeigeWirklichLoeschFenster(){
    l.macheSichtbar();
    k=lis.getContent();
    l.setName(k.getName());
    l.setStrasse(k.getStrasse());
    l.setPLZ(k.getPLZ());
    l.setWohnort(k.getWohnort());
  }
  void versteckeWirklichLoeschFenster(){
      l.macheUnsichtbar();
  }
  void macheSichtbar(){
    menue.setVisible(true);
  }
  void macheUnsichtbar(){
    menue.setVisible(false);
  }
  void nimmListe(List<Karte> li){
    lis=li;
  }
}
