 /**
 * <p>Qualitaets- und UnterstuetzungsAgentur - Landesinstitut fuer Schule, Materialien zum schulinternen Lehrplan Informatik SII</p>
  *
 * @version 2014-03-13
 */
import javax.swing.*;
import java.awt.event.*;
import java.awt.*;

class SuchFenster {
  JFrame menue;
  JTextField name, strasse,plz, wohnort ;
  JLabel anzeigeName, anzeigeStrasse,anzeigePLZ, anzeigeWohnort;
  JButton suchen;
  JPanel contentPane;
  SuchKlickEmpfaenger klemp;
  GridLayout grilay;
  List<Karte> lis;
  Hauptansicht haupt;

  SuchFenster(List<Karte> l,Hauptansicht h){
    lis=l;
    haupt=h;
    menue=new JFrame("Suchen");
    contentPane=new JPanel();
    grilay=new GridLayout(0,2);
    contentPane.setLayout(grilay);
    klemp=new SuchKlickEmpfaenger(this,lis, haupt);
    anzeigeName=new JLabel("Name: ");
    anzeigeStrasse=new JLabel("Strasse: ");
    anzeigePLZ=new JLabel("PLZ: ");
    anzeigeWohnort=new JLabel("Wohnort: ");
    name=new JTextField("",20);
    strasse=new JTextField("",20);
    plz=new JTextField("",20);
    wohnort=new JTextField("",20);
    suchen=new JButton("Suche starten");
    suchen.addActionListener(klemp);
    contentPane.add(anzeigeName);
    contentPane.add(name);
    contentPane.add(anzeigeStrasse);
    contentPane.add(strasse);
    contentPane.add(anzeigePLZ);
    contentPane.add(plz);
    contentPane.add(anzeigeWohnort);
    contentPane.add(wohnort);
    contentPane.add(suchen);
    menue.setContentPane(contentPane);
    menue.pack();
    menue.setVisible(true);

  }
  void macheSichtbar(){
    menue.setVisible(true);
  }
  void macheUnsichtbar(){
    menue.setVisible(false);
  }
  String getName(){
    return name.getText();
  }
  String getWohnort(){
   return wohnort.getText();
  }
  int getPLZ(){
   if(!plz.getText().equals(""))
    return Integer.parseInt(plz.getText());
   else return 0;
  }
  String getStrasse(){
    return strasse.getText();
  }
  void setName(String na){
    name.setText(na);
  }
  void setWohnort(String w){
   wohnort.setText(w);
  }
  void setPLZ(int i){
    plz.setText(""+i);
  }
  void setStrasse(String str){
    strasse.setText(str);
  }
}